#ifndef __MORE_APPLE_DEFS_H__
#define __MORE_APPLE_DEFS_H__

#pragma pack(2)

typedef UInt32 IOCommandID;
typedef UInt32 Size;
typedef UInt32 VSLGestaltType;
typedef UInt32 InterruptServiceType;
typedef void * HardwareCursorDescriptorPtr;
typedef void * HardwareCursorInfoPtr;
typedef UInt32 InterruptServiceIDType;
typedef UInt32 * InterruptServiceIDPtr;
typedef UInt32	InterruptSetID;
typedef UInt32  InterruptSetOptions;
typedef UInt32	InterruptMemberNumber;

typedef void (*InterruptEnabler)(IONDRVInterruptSetMember setMember, void *refCon);
typedef void (*InterruptDisabler)(IONDRVInterruptSetMember setMember, void *refCon);
typedef void (*InterruptHandler)(IONDRVInterruptSetMember setMember, void *refCon, UInt32 theIntCount);


struct IONDRVControlParameters {
    UInt8	__reservedA[0x1a];
    UInt16	code;
    void *	params;
    UInt8	__reservedB[0x12];
};

struct DriverInitInfo {
    UInt16                          refNum;
    RegEntryID                      deviceEntry;
};

struct CntrlParam {
    void *                          qLink;
    short                           qType;
    short                           ioTrap;
    void *                          ioCmdAddr;
    void *                          ioCompletion;
    short                           ioResult;
    char *                          ioNamePtr;
    short                           ioVRefNum;
    short                           ioCRefNum;
    short                           csCode;
    void *                          csParams;
    short                           csParam[9];
};
typedef struct CntrlParam CntrlParam, *CntrlParamPtr;

enum {
    kOpenCommand                = 0,
    kCloseCommand               = 1,
    kReadCommand                = 2,
    kWriteCommand               = 3,
    kControlCommand             = 4,
    kStatusCommand              = 5,
    kKillIOCommand              = 6,
    kInitializeCommand          = 7,                            /* init driver and device*/
    kFinalizeCommand            = 8,                            /* shutdown driver and device*/
    kReplaceCommand             = 9,                            /* replace an old driver*/
    kSupersededCommand          = 10                            /* prepare to be replaced by a new driver*/
};
enum {
    kSynchronousIOCommandKind   = 0x00000001,
    kAsynchronousIOCommandKind  = 0x00000002,
    kImmediateIOCommandKind     = 0x00000004
};


extern OSStatus    CallTVector( 
	    void * p1, void * p2, void * p3, void * p4, void * p5, void * p6,
	    struct IOTVector * entry );

struct VDConfigurationFeatureListRec
{
    OSType *	csConfigFeatureList;
    ItemCount	csNumConfigFeatures;
    UInt32	csReserved1;
    UInt32	csReserved2;
};

enum { cscGetFeatureList = 39 };

enum
{
    kDVIPowerSwitchFeature        = (1 << 0),	/* Used for csConfigFeature*/
    kDVIPowerSwitchSupportMask    = (1 << 0),	/* Read-only*/
    kDVIPowerSwitchActiveMask     = (1 << 0),	/* Read/write for csConfigValue*/
    kDVIPowerSwitchPowerOffDelay  = 200		/* ms before power off */
};

enum
{
    kIODVIPowerEnableFlag = 0x10000,
    kIOI2CPowerEnableFlag = 0x20000
};

enum { kIONDRVAVJackProbeDelayMS = 1000 };

enum {
    cscSleepWake = 0x86,
    sleepWakeSig = 'slwk',
    vdSleepState = 0,
    vdWakeState  = 1
};

struct VDSleepWakeInfo
{
    UInt8	csMode;
    UInt8	fill;
    UInt32	csData;
};
typedef struct VDSleepWakeInfo VDSleepWakeInfo;

#pragma pack()

#endif /* __MORE_APPLE_DEFS_H__ */
