/*
 * Copyright (c) 1998-2000 Apple Computer, Inc. All rights reserved.
 *
 * @APPLE_LICENSE_HEADER_START@
 * 
 * Copyright (c) 1999-2003 Apple Computer, Inc.  All Rights Reserved.
 * 
 * This file contains Original Code and/or Modifications of Original Code
 * as defined in and that are subject to the Apple Public Source License
 * Version 2.0 (the 'License'). You may not use this file except in
 * compliance with the License. Please obtain a copy of the License at
 * http://www.opensource.apple.com/apsl/ and read it before using this
 * file.
 * 
 * The Original Code and all software distributed under the License are
 * distributed on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND, EITHER
 * EXPRESS OR IMPLIED, AND APPLE HEREBY DISCLAIMS ALL SUCH WARRANTIES,
 * INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT OR NON-INFRINGEMENT.
 * Please see the License for the specific language governing rights and
 * limitations under the License.
 * 
 * @APPLE_LICENSE_HEADER_END@
 */


#include "IOMacOSTypes.h"

/*
 * Note about library entrypoints. Linux doesn't use a TOC, but we do need
 * a trampoline for converting calling conventions. In order to do that
 * in a simple way, the library entries are filled with a pointer to the
 * trampoline code as the function address and a pointer to this data
 * structure in the TOC
 */
#define MAKEFUNC(name, func) { name, (void*)LibraryTrampoline, 0, (void *)func }
#define ENDFUNC() { NULL, NULL, NULL }

extern void LibraryTrampoline(void);

struct FunctionEntry
{
	char        *   name;
	LogicalAddress  address;	/* Trampoline */
	LogicalAddress  toc;		/* This structure */
	LogicalAddress  function;	/* Real function pointer */
};
typedef struct FunctionEntry FunctionEntry;

struct LibraryEntry
{
    char        *   name;
    FunctionEntry * functions;
};
typedef struct LibraryEntry LibraryEntry;

extern LibraryEntry IONDRVLibraries[];
extern const ItemCount  IONumNDRVLibraries;
