#ifndef __NDRVER_H__
#define __NDRVER_H__

#include "IOMacOSTypes.h"
#include "IONDRVSupport.h"
#include "IOPEFLoader.h"
#include "IOPEFLibraries.h"

struct ndrv_inst;

#include "nrlib.h"
#include "ndrvpci.h"
#include "ndrviospy.h"

#include "MoreAppleDefs.h"

extern void log_printf(const char* fmt, ...);

#define LOG_INFO(fmt...)	log_printf(fmt)
#define LOG_ERR(fmt...)		log_printf(fmt)
#define LOG_DBG(fmt...)		log_printf(fmt)
//#define LOG_DBG(fmt...)	do {} while(0)

struct ndrv_pci_inst;

struct ndrv_inst
{
	struct device_node		*node;

	PCodeInstance			pinst;
	struct IOTVector		*sDoDriverIO;
	struct IODriverDescription	*sDriverDescription;

	struct ndrv_pci_inst		*pcidata;

	void				*rawpef;
	long				rawsize;

	struct ndrv_inst		*next;
};

extern struct ndrv_inst	*ndrvs;

#endif /* __NDRVER_H__ */
