#ifndef __NRLIB_H__
#define __NRLIB_H__

struct property
{
	char			*name;
	int			length;
	void			*value;
	struct property		*next;
};

struct device_node
{
	char			*name;
	char			*full_name;

	struct property		*properties;

	struct device_node	*parent;
	struct device_node	*child;
	struct device_node	*sibling;
	struct device_node	*allnext;
};

extern struct device_node *dtroot, *allnodes, *macionode;

#define REGENTRY_TO_DN(entry)		((entry) ? ((struct device_node *)(entry)->opaque[0]) : NULL)
#define SET_REGENTRY_TO_DN(entry, dn)	do { (entry)->opaque[0] = (dn); } while(0)

/* Initialize the library */
extern int nrlib_initialize(void);

/* Accessors */
extern void *get_property(struct device_node *np, const char *name, int *length);
extern int set_property(struct device_node *np, const char *name, void *value, int size);
extern int device_is_compatible(struct device_node *device, const char *compat);


/* Include Apple definitions */
#include "NameRegistry.h"

#endif /* __NRLIB_H__ */
